/* RPG Second Attempt (name coming eventually... maybe.)

		   By: Erik Eriksen
   Start date: 7-21-05

*/ 
#include <iostream>
#include <stdio.h>
#include <cstdlib> //for random numbers
#include "/home/erik/rpg/LConsole.h"
#include "/home/erik/rpg/Cplayer.h"
#include "/home/erik/rpg/Cenemy.h"
#include "/home/erik/rpg/Cdraw.h"

using namespace std;

void castleVisit(int area); //displays current story for current area.
void viewTitleScreen();

int main()
{
	bool game = true, actionDone = false, areaChanged = false;
	unsigned int seed;
	int areaNumber = 1, resetAt = 0, pickedNumber;
	int difficultyNum = 0, numOfScreens;
	int event; // value returned from collision detect.
	party member[3];  //4 party members 
	enemy e; //again, short.
	draw gfx; //controls screen graphics
	char viewStat, nameParty; //used when asked for initial stat view.
	string difficulty;

	cout << "Game attack seed: ";
	cin >> seed;
	cout << "Select Game Difficulty:\n (E)asy\n (M)edium\n (H)ard\n (I)mpossible\nChoice: ";
	
	while (difficultyNum == 0)
	{
	cin >> difficulty;
	
	if ((difficulty == "E") || (difficulty == "e"))
		difficultyNum = 1000;
	else if ((difficulty == "M") || (difficulty == "m"))
		difficultyNum = 800;
	else if ((difficulty == "H") || (difficulty == "h"))
		difficultyNum = 500;
	else if ((difficulty == "I") || (difficulty == "i"))
		difficultyNum = 20;
	else if ((difficulty == "D") || (difficulty == "d")) //debug, almost no battles
		difficultyNum = 32000;
	else 
		cout << "ERROR: Invalid selection! Please re-enter.\n";
	}
	
	srand(seed);
/*start of pregame setup (commented out for debugging purposes)
	gfx.cls();
	viewTitleScreen();
	gfx.cls();
	printf("Welcome to RPG second attempt working development\n\n");
    printf("Um, yeah. Not much to say here yet except that you are a group of evil people set out on ruling the land, but find out there's a bigger evil and end up saving the day. Now let's begin!\n\n");
    printf("Enter name of your character: ");
	member[0].inputName();
	
	cout << "Welcome " << member[0].displayName() << "! ";
	printf("Please select a character class to play as:\n");
	printf(" 1) Fighter - Strong melee warrior, but dumb as an ox.\n");
	printf(" 2) Archer  - Weaker than fighter, but greater attack accuracy\n");
	printf(" 3) Mage    - Physically very weak but is extremely strong mentally\n");
	member[0].setPlayerType(0);
	
	printf("Ah! Great choice! Now let me just initialize you're party's stats...\n");
	for (int i = 0; i <= 3; i++)
		member[i].initStats(i);
	for (int i = 1; i <= 3; i++)
		member[i].setPlayerType(i);
	
	printf("All done!\n\n");
	
	printf("Would you like to name your other 3 party members or use game defaults?\n");
	printf("[N]ame them.\n");
	printf("[U]se game defaults.\n");
	cin >> nameParty;
	
	if (nameParty == 'n' || nameParty == 'N')
	{
		for (int i = 1; i <= 3; i++)
		{
			printf("Enter name of party member %i: ", (i + 1));
			member[i].inputName();
		}
	}
	
	else
	{
		printf("Using default values for member names...\n");
		for (int i = 1; i <= 3; i++)
			member[i].defaultName(i);
	}
	
	printf("Would you like to display these stats now? [y/n] ");
	cin >> viewStat;
	
	if (viewStat == 'y' || viewStat == 'Y')
	{
		for (int i = 0; i <= 3; i++)
			member[i].viewStats();
	}
	
	else
		printf("Ok, maybe some other time...\n");

	
	printf("Starting game...\n");
	
//end of pre-game setup*/
	
//start of game
	
	//initialization stuff
	gfx.cls();
	numOfScreens = 0; //starts in town
	gfx.setArea(areaNumber, numOfScreens);
	gfx.setPlayerPos(15,15);
	gfx.playerAtLoc();
	SetTTYRaw(true); //starts kb unblock mode with echo hiding.
	
	member[0].setReady();
	
	int keyHit, isRead;
	
	while (game == true)
	{
		pickedNumber = rand() % difficultyNum + 1;
		isRead = IsKBHit(); //scans to see if keyboard is hit.
		
		if (isRead == 1) //if it is indeed hit
		{
			keyHit = ReadKeyboard();
			if (keyHit == LC_KEY_RIGHT)
			{
				if (gfx.checkInBounds(0)) //0 = heading right
					gfx.movePlayer(1,0);
			}
			else if (keyHit == LC_KEY_LEFT)
			{
				if (gfx.checkInBounds(1)) // 1 = heading left
					gfx.movePlayer(-1, 0);				
			}
			else if (keyHit == LC_KEY_UP)
			{
				if (gfx.checkInBounds(2)) // 2 = up
					gfx.movePlayer(0, -1);
			}
			else if (keyHit == LC_KEY_DOWN)
			{
				if (gfx.checkInBounds(3)) // 3 = down
					gfx.movePlayer(0, 1);
			}
			
			else if (keyHit == 'q')
				game = false;
			
			event = gfx.checkCollision();
			switch (event)
			{
				case 0: //went to area entrance
					if (areaNumber == 1)
					{
						SetCursorPos(1, 22);
						printf("The adventures just begun! You can't turn back now!\n");
						
					}
					else
					{
						areaNumber--;
						resetAt = 0; // 0 = going back an area.
						numOfScreens++; //one more screen to next town
						areaChanged = true;
					}
					actionDone = true;
					break;
					
				case 1: //went to area exit
					if (member[0].wentToCastle() == true)
					{
						areaNumber++;
						resetAt = 1; // 1= going forward an area.
						numOfScreens--; //one less screen to next town
						areaChanged = true;
						
					}
					else
					{
						SetCursorPos(1, 22);
						printf("You don't even know where you're going yet! How can you leave?\n");
						
					}
					actionDone = true;
					break;
					
				case 2: //castle
					gfx.cls();
					castleVisit(areaNumber); //displays castle story for current area
					member[0].setReady();
					actionDone = true;
					break;
					
				case 3: //inn
					break;
					
				case 4: //weapon shop
					break;
					
				case 5: //magic shop
					break;
					
				default:
					break;
			} //switch end
					
		} // keyboard read end
		
		if (actionDone == true)
		{
			actionDone = false;
			gfx.cls();
			gfx.setArea(areaNumber, numOfScreens);
			if (areaChanged == true)
			{
				gfx.resetPlayerPos(resetAt);
				areaChanged = false;
			}
			if (numOfScreens <= 0) //reseting # of screens
				numOfScreens = gfx.numAdventureScreens(areaNumber);
			gfx.playerAtLoc();
		}
		
		//enemy attack (after all this so player always has first move on area)
		
		/*NOT EXACTLY WORKING!!! INFINITE LOOP! =-O!!!
		if ((pickedNumber == (difficultyNum / 2)) && (areaNumber % 2 == 0))
		{ //if in even area numbers (not towns and random number picked = battle # FIGHT!
			gfx.cls();
			cout << "BATTLE!\n";
		//battle code goes here
		}*/
			
		
	}
		
	
		
	RestoreTTY(); //ends kb unblock mode.
	
	return 0;
}

void castleVisit(int area)
{
	int yep;
	switch (area)
	{
		case 1: //area 1's story board.
			
			SetCursorPos(0, 0);
			cout << "Welcome! Welcome! We've been expecting you. You see tension has arrose between blah blah blah.\n\n";
			cout << "More on story coming at a much later date.\n\nPlease press enter";
			cin >> yep;
			break;
				
		default:
			cout << "Unknown error: Invalid area number passed to function 'void castleVisit(int, party)'\n";
			cin >> yep;
			break;
	}
}

void viewTitleScreen()
{
	char nothing;
	cout << "             R      P     G \n";
    cout << "             Second+Attempt\n\n\n";
	cout << "             Press any key\n\n\n";
	cout << "       (c) 2005 Nukem Enterprises\n";
	cin >> nothing;
}
/*

Updates:
 --------
 8-27-05: I worked a lot on randomizing everything. all areas are randomized to the area
 number that they are. Making it mostly the same every time you go back and forth between
 areas. Trees are added to adventure areas and towns are now also random. There is also
 a random amount of screens between towns. Town number needs to be counted so that they
 are dynamic. Differences between area exit and entrance might be a good idea seeing that
 it can get a bit confusing. Not sure yet if I just made the game TOO random to be good.

 8-26-05: Yeah I know, long time no updates. Well I fixed the area changing so the plyr
 appears in the correct spot. Also started to add a difficulty option. It basically just
 makes the bad guys appear more when you're in the "battle screen" areas. Finally, also
 started to add a title screen and actual fighting. 
 
 7-27-05: Did a lot with area and collision detection. Movement works fine and so does
 quit. Still problem with reseting the character when changing areas. That should be
 easily fixed. 

 7-25-05: Got the character moving, changed player to a party class. Mulitple people
 in party now. Added a bit to the inital start up so all members are initialized and
 set up. Working on area and collision detection now. Also some buttons need to be
 figured out. (quit?) 

 Added draw class to handle all gfx.

 Added enemy class also, but still empty at the time. 

 Don't know what else I did but it was a lot... a lot a lot.

 7-23-05: This is my second update. After a 2 day trip over at GameDev.net and a
 headache caused by that damned cursors.h header file (which still doesn't work, 
 go figure) I finally got the screen control under... well control. Great thanks to
 Tinyn over at GameDev for the header + source file for the needed functions.

 So the game is indeed going to be a top view ascii RPG as I hoped. (in possible color)
 I'm thinking I'm going to keep it relatively short so that the project doesn't get
 so big and complicated that it can't be updated.
 
 I'm out of time today (work in 40 minutes) but now that I have a SetCursorPos(x,y)
 function I think next time I can sit down I should get a lot done.

 7-21-05: This is my first update of this project, my first real C++ project in about
 3/4 a year. I'm just currently working on the basic ideas of the game. story and all
 that stuff will come after. (Way after)
 

TO DO / BEEN DONE LIST:
-----------------------

 what's been done:
   7-21-05:
    very basic level up + stat system worked out. 
    player class created for maintaining player info.
    welcome screen / game init screen created.
   
   7-23-05:
    Got SetCursorPos(x,y) functions from gamedev also screen handling funcs.
    Moved everything into seperate files to decrease clutter.
	Moved commment area to bottom of main.cpp so codes easier to see.

   7-25-05:
    Character movement set up.
	added party class for multi-members.
	initializations all set up.

   7-27-05:
	Lots of gfx work done. 
	 ->basic town set up and start of area2.
	area changing started.
	collision detection working for the most part.
	lots of little odds and ends.

   8-26-05:
	Character reseting after area change finished.
	Started work on title screen
	Started difficutly idea (higher diff = more battles)
	Started fighting code part (random # seed + such)

   8-27-05
	Areas now generated randomly but stay the same in same game.
	Trees added to adventure levels.
	Distance between towns worked out (still needs some more work though)

 what needs to be done:
   continue working on areas
   --> collision detection of trees?
   --> area entrance and exit differentation
   --> glitches in screen counting.
       --> need to start counting towns so they are dynamic!!!
   battling.
   inventory system?
   magic system?
   balance out stats and lvling system (in future)
   story? (basic idea)

  current line count: couple hundred? unknown.

*/
